/**
 * Copyright (c) 2021 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "../../libs.h"
#include "../shaderprogram.h"

#define STANDARD_SHADER_UNIFORM_NAME_VIEW "u_View"
#define STANDARD_SHADER_UNIFORM_NAME_PROJ "u_Proj"
#define STANDARD_SHADER_UNIFORM_NAME_TEXT "u_Text"
#define STANDARD_SHADER_UNIFORM_NAME_MODEL "u_Model"
#define STANDARD_SHADER_UNIFORM_NAME_COLOR "u_Color"

typedef struct {
  shaderprogram_t shader;

  shaderuniform_t uniformView;
  shaderuniform_t uniformProjection;
  shaderuniform_t uniformPosition;
  shaderuniform_t uniformTexture;
  shaderuniform_t uniformColor;
} standardshader_t;

void standardShaderInit(standardshader_t *stds, char *vert, char *frag);